unit teilertool;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, math, Spin;

const
  E6: array[0..5]  of integer = (10, 15, 22, 33, 47, 68);
  E12:array[0..11] of integer = (10,12, 15,18, 22,27, 33, 39,47,56, 68,82);
  E24:array[0..23] of integer = (10,11,12,13,15,16,18,20,22,24,27,30,33,36,39,43,47,51,56,62,68,75,82,91);

type
  TFormSpannungsteiler = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    EditR2: TEdit;
    EditR1: TEdit;
    EditU2: TEdit;
    EditU1: TEdit;
    RadioGroupE: TRadioGroup;
    Label1: TLabel;
    ListBoxR1: TListBox;
    LabelStrom: TLabel;
    Labelu2Ist: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox1: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    RadioButton2: TRadioButton;
    RadioButton1: TRadioButton;
    Label16: TLabel;
    Label17: TLabel;
    PanelCurrentRange: TPanel;
    EditStromMin: TEdit;
    EditStromMax: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    LabelR2: TLabel;
    LabelR1: TLabel;
    Shape9: TShape;
    Shape10: TShape;
    SpinButtonR1: TSpinButton;
    SpinButtonR2: TSpinButton;
    SpinButtonStrom: TSpinButton;
    LabelU1V: TLabel;
    LabelU2V: TLabel;
    LabelAbweichung: TLabel;
    RadioButton3: TRadioButton;
    Label9: TLabel;
    RadioButton4: TRadioButton;
    Label10: TLabel;
    Label13: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    RadioButton5: TRadioButton;
    Label20: TLabel;
    LabelU1ist: TLabel;
    LabelR2Watt: TLabel;
    LabelR1Watt: TLabel;
    GroupBoxToleranz: TGroupBox;
    EditToleranz: TEdit;
    Label21: TLabel;
    Label22: TLabel;
    LabelUtoleranz: TLabel;
    Label3Punkte: TLabel;
    LabelU2min: TLabel;
    LabelU2max: TLabel;
    LabelU2Delta: TLabel;
    Label24: TLabel;
    LabelDeltaProzent: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroupEClick(Sender: TObject);
    procedure RadioButtonClick(Sender: TObject);
    procedure SpinButtonR1UpClick(Sender: TObject);
    procedure SpinButtonR1DownClick(Sender: TObject);
    procedure SpinButtonR2DownClick(Sender: TObject);
    procedure SpinButtonR2UpClick(Sender: TObject);
    procedure EditStromMinMaxChange(Sender: TObject);
    procedure SpinButtonStromUpClick(Sender: TObject);
    procedure SpinButtonStromDownClick(Sender: TObject);
    procedure EditToleranzChange(Sender: TObject);
    procedure EditR2KeyPress(Sender: TObject; var Key: Char);
    procedure EditR1KeyPress(Sender: TObject; var Key: Char);
    procedure EditU2KeyPress(Sender: TObject; var Key: Char);
    procedure EditU1KeyPress(Sender: TObject; var Key: Char);
    procedure EditStromMaxKeyPress(Sender: TObject; var Key: Char);
    procedure EditStromMinKeyPress(Sender: TObject; var Key: Char);
    procedure EditToleranzKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
    u1,u2,r1,r2:double;
    Imin,Imax, Iist:double;
    IminLimit,ImaxLimit:double;
    toleranz:double;
    error:boolean;
  public
    reihe:array[1..240] of double;
    reiheAnzahl:integer;
    sucheAufwaerts:boolean;
    { Public-Deklarationen }
    procedure calc1;
    procedure calc2;
    procedure calc3;
    procedure calc4;
    procedure calc5;
    procedure erzeugeReihe(e:byte);
    function  nextVal(val:string):string;
    function  prevVal(val:string):string;
    function  numToRtxt(val: double): String;
    function  RtxtToNum(txt:string): double;
    function  stromausgabe(i:double):string;
    function  spannungsausgabe(u:double):string;
    function  leistungssausgabe(p:double):string;
    procedure Berechne;
    procedure Toleranzberechnung(u1,u2,r1,r2:double);
    procedure ToleranzberechnungU1(u1,u2,r1,r2:double);
  end;

var
  FormSpannungsteiler: TFormSpannungsteiler;

implementation
//uses Rechner;
{$R *.DFM}

{ TForm1 }

procedure TFormSpannungsteiler.calc1;   //Geg:U1, R1, R2   Ges:U2
begin
  error:=false;
  try
    u1:=StrToFloat(EditU1.text);
    r1:=RtxtToNum(EditR1.text);
    r2:=RtxtToNum(EditR2.text);
    u2:=u1* (r1/(r1+r2));
    EditU2.text:=floatToStr(u2);
    Labelu2Ist.caption:=spannungsausgabe(u2);
    Iist:=u1 / (r1+r2);
    labelStrom.caption:=stromausgabe(Iist);

    Toleranzberechnung(u1,u2,r1,r2);
{
    r1max:=r1*(1+toleranz);
    r2max:=r2*(1+toleranz);
    r1min:=r1*(1-toleranz);
    r2min:=r2*(1-toleranz);
    u2min:=u1* (r1min/(r1min+r2max));
    u2max:=u1* (r1max/(r1max+r2min));

    LabelU2min.Caption:=spannungsausgabe(u2min);
    LabelU2max.Caption:=spannungsausgabe(u2max);
    LabelU2Delta.caption:=spannungsausgabe(u2max-u2min)+' ('+floatToStrF( 100*((u2max-u2min)/u2),ffFixed,4,2)+'%)';

//    LabelU2DeltaProzent.caption:=floatToStrF( 100*((u2max-u2min)/u2),ffFixed,4,2);
    Application.ProcessMessages;
    LabelU2Delta.Left:=labelU2min.left + labelU2min.width;
//    LabelU2max.Left:=Label3Punkte.Left + Label3Punkte.width + 4;
    LabelU2max.Left:=LabelU2Delta.left+ LabelU2Delta.width;
    Label3Punkte.Left:=LabelU2Delta.left + (LabelU2Delta.width - Label3Punkte.width) div 2 ;
}    
  except
    error:=true;
    Labelu2Ist.caption:='-?-';
    labelStrom.caption:='I=-?-';
  end;
end;

procedure TFormSpannungsteiler.erzeugeReihe(e: byte);
var
  dekade, i:integer;
  mult:double;
begin

  reiheAnzahl:=0;
  listboxR1.clear;
  for dekade:=-3 to 6 do begin
    mult:=power(10,dekade);
    case e of
    0: begin
         for i:=low(E6) to high(E6) do begin
           inc(reiheAnzahl);
           reihe[reiheAnzahl] := mult * E6[i];
           listboxR1.items.add(numToRtxt(reihe[reiheAnzahl]));
         end;
         ListBoxR1.ItemIndex:=6*4;
       end;
    1: begin
         for i:=low(E12) to high(E12) do begin
           inc(reiheAnzahl);
           reihe[reiheAnzahl] := mult * E12[i];
           listboxR1.items.add(numToRtxt(reihe[reiheAnzahl]));
         end;
         ListBoxR1.ItemIndex:=12*4;
       end;
    2: begin
         for i:=low(E24) to high(E24) do begin
           inc(reiheAnzahl);
           reihe[reiheAnzahl] := mult * E24[i];
           listboxR1.items.add(numToRtxt(reihe[reiheAnzahl]));
         end;
         ListBoxR1.ItemIndex:=24*4;
       end;
    end;
  end;
end;

procedure TFormSpannungsteiler.FormCreate(Sender: TObject);
begin
  erzeugeReihe(1);
  label1.caption:=intToStr(reiheAnzahl);
  sucheAufwaerts:=true;

  iMaxLimit:=5;
  Imax:=iMaxLimit;
  EditStromMax.text:=floatToStr(iMax);

  iMinLimit:=0.1;
  Imin:=iMinLimit;
  EditStromMin.text:=floatToStr(iMin);
  toleranz:=0.01;
  Berechne;
end;

procedure TFormSpannungsteiler.RadioGroupEClick(Sender: TObject);
begin
  erzeugeReihe(RadiogroupE.itemindex);
  Berechne;
end;

function TFormSpannungsteiler.numToRtxt(val: double): String;
var
  x,l,r:integer;
begin
  if val >= 1000000 then begin
    x:=round(val);
    l:=x div 1000000;
    r:=x mod 1000000;
    while (0=r mod 10) and (r>0) do r:=r div 10;
    if (r>0)
    then result:=intToStr(l)+'M'+intToStr(r)
    else result:=intToStr(l)+'M';
  end
  else
  if val >= 1000 then begin
    x:=round(val);
    l:=x div 1000;
    r:=x mod 1000;
    while (0=r mod 10) and (r>0) do r:=r div 10;
    if (r>0)
    then result:=intToStr(l)+'K'+intToStr(r)
    else result:=intToStr(l)+'K';
  end
  else begin
    x:=round(val*1000);
    l:=x div 1000;
    r:=x mod 1000;
    result:=intToStr(l)+'R';
    x:=100;
    while (r>0) and (x>0) do begin
      result:= result+intToStr(r div x);
      r:=r mod x;
      x:=x div 10;
    end;
  end;
end;

procedure TFormSpannungsteiler.calc2;  //Geg:U1, U2   Ges:R1,R2
var
  bdiff,u2Ist,diff,strom,abweichung:double;
  i,j:integer;
  bi, bj:integer; //Bestes i,j
begin
  try
    u1:=StrToFloat(EditU1.text);
    u2:=StrToFloat(EditU2.text);
    bdiff := 1e8;
    bj:=1;
    bi:=1;
    if sucheAufwaerts then begin
      for i:=1 to reiheAnzahl do begin
        for j:=1 to reiheAnzahl do begin
          u2Ist:=u1*reihe[i] / (reihe[i]+reihe[j]);
          strom:=U1 / (reihe[i]+reihe[j]) *1000;
          if (strom >= iMin) and (strom <= iMax) then begin
            diff:=abs(u2Ist-u2);
            if diff <= bdiff then begin
              bdiff:=diff;
              bi:=i;
              bj:=j;
            end;
          end;
        end;
      end;
    end else begin
      for i:=reiheAnzahl downto 1 do begin
        for j:=reiheAnzahl downto 1 do begin
          u2Ist:=u1*reihe[i] / (reihe[i]+reihe[j]);
          strom:=U1 / (reihe[i]+reihe[j]) *1000;
          if (strom >= iMin) and (strom <= iMax) then begin
            diff:=abs(u2Ist-u2);
            if diff <= bdiff then begin
              bdiff:=diff;
              bi:=i;
              bj:=j;
            end;
          end;
        end;
      end;
    end;


    if bdiff < 1e8 then begin
      editR1.text:=numToRtxt(reihe[bi]);
      editR2.text:=numToRtxt(reihe[bj]);
      LabelR1.caption:=numToRtxt(reihe[bi]);
      LabelR2.caption:=numToRtxt(reihe[bj]);
      Iist:=U1 / (reihe[bi]+reihe[bj]);
      labelStrom.caption:=stromausgabe(Iist);
      u2Ist:=u1*reihe[bi] / (reihe[bi]+reihe[bj]);
      labelu2Ist.caption:=spannungsausgabe(u2Ist);
      abweichung:=100*((u2Ist-u2)/u2);
      LabelAbweichung.caption:='Abweichung: '+floatToStrF(abweichung, ffFixed,7,2)+'%';
      Toleranzberechnung(u1,u2ist,reihe[bi],reihe[bj]);
    end;
  except
    Labelu2Ist.caption:='-?-';
    labelStrom.caption:='I=-?-';
    LabelAbweichung.caption:='-?-';
    LabelR1.caption:='-?-';
    LabelR2.caption:='-?-';
  end;

end;

procedure TFormSpannungsteiler.Berechne;
begin
  if radiobutton1.checked then begin
    panelCurrentRange.visible:=false;
    editU1.visible:=true;
    editU2.visible:=false;
    editR1.visible:=true;
    editR2.visible:=true;
    labelU1Ist.visible:=false;
    labelu2Ist.visible:=true;
    labelR1.visible:=false;
    labelR2.visible:=false;
    labelu2Ist.top:=240;
    SpinButtonStrom.visible:=false;
    SpinButtonR1.visible:=true;
    SpinButtonR2.visible:=true;
    LabelU1V.visible:=true;
    LabelU2V.visible:=false;
    LabelAbweichung.visible:=false;
    calc1;
  end
  else
  if radiobutton2.checked then begin
    panelCurrentRange.visible:=true;
    editU1.visible:=true;
    editU2.visible:=true;
    editR1.visible:=false;
    editR2.visible:=false;
    labelR1.visible:=true;
    labelR2.visible:=true;
    labelU1Ist.visible:=false;
    labelu2Ist.visible:=true;
    labelu2Ist.top:=264;
    SpinButtonStrom.visible:=true;
    SpinButtonR1.visible:=false;
    SpinButtonR2.visible:=false;
    LabelU1V.visible:=true;
    LabelU2V.visible:=true;
    LabelAbweichung.visible:=true;
    calc2;
  end
  else
  if radiobutton3.checked then begin
    panelCurrentRange.visible:=false;
    editU1.visible:=true;
    editU2.visible:=true;
    editR1.visible:=true;
    editR2.visible:=false;
    labelR1.visible:=false;
    labelR2.visible:=true;
    labelU1Ist.visible:=false;
    labelu2Ist.visible:=true;
    labelu2Ist.top:=264;
    SpinButtonStrom.visible:=false;
    SpinButtonR1.visible:=true;
    SpinButtonR2.visible:=false;
    LabelU1V.visible:=true;
    LabelU2V.visible:=true;
    LabelAbweichung.visible:=true;
    calc3;
  end
  else
  if radiobutton4.checked then begin
    panelCurrentRange.visible:=false;
    editU1.visible:=true;
    editU2.visible:=true;
    editR1.visible:=false;
    editR2.visible:=true;
    labelR1.visible:=true;
    labelR2.visible:=false;
    labelU1Ist.visible:=false;
    labelu2Ist.visible:=true;
    labelu2Ist.top:=264;
    SpinButtonStrom.visible:=false;
    SpinButtonR1.visible:=false;
    SpinButtonR2.visible:=true;
    LabelU1V.visible:=true;
    LabelU2V.visible:=true;
    LabelAbweichung.visible:=true;
    calc4;
  end
  else
  if radiobutton5.checked then begin
    panelCurrentRange.visible:=false;
    editU1.visible:=false;
    editU2.visible:=true;
    editR1.visible:=true;
    editR2.visible:=true;
    labelU1ist.visible:=true;
    labelu2Ist.visible:=false;
    labelR1.visible:=false;
    labelR2.visible:=false;
    labelu2Ist.top:=240;
    labelU1Ist.visible:=true;
    SpinButtonStrom.visible:=false;
    SpinButtonR1.visible:=true;
    SpinButtonR2.visible:=true;
    LabelU1V.visible:=false;
    LabelU2V.visible:=true;
    LabelAbweichung.visible:=false;
    calc5;
  end;
  LabelR1Watt.caption:=leistungssausgabe(Iist*Iist*r1);
  LabelR2Watt.caption:=leistungssausgabe(Iist*Iist*r2);


end;

procedure TFormSpannungsteiler.RadioButtonClick(Sender: TObject);
begin
  Berechne;
end;

function TFormSpannungsteiler.RtxtToNum(txt: string): double;
var
  p:integer;
  faktor:double;
begin
  txt:=uppercase(trim(txt));
  faktor:=1;
  p:=pos('M',txt);
  if p>0 then begin
    txt[p]:=decimalseparator;
    faktor:=1e6;
  end;
  p:=pos('K',txt);
  if p>0 then begin
    txt[p]:=decimalseparator;
    faktor:=1e3;
  end;
  p:=pos('R',txt);
  if p>0 then begin
    txt[p]:=decimalseparator;
  end;
  result:=strToFloat(txt)*faktor;
end;

procedure TFormSpannungsteiler.SpinButtonR1UpClick(Sender: TObject);
begin
  editR1.text:=nextVal(editR1.text);
end;

function TFormSpannungsteiler.nextVal(val: string): string;
var
  r:double;
  i:integer;
begin
  r:= RtxtToNum(val);
  i:=1;
  while (i<reiheAnzahl) and (reihe[i] <= r+0.000001) do inc(i);
  result:=numtoRtxt(reihe[i]);
end;

function TFormSpannungsteiler.prevVal(val: string): string;
var
  r:double;
  i:integer;
begin
  r:= RtxtToNum(val);
  i:=1;
  while (i<reiheAnzahl) and (reihe[i] < r-0.000001) do inc(i);
  dec(i);
  if i<1 then i:=1;
  result:=numtoRtxt(reihe[i]);
end;

procedure TFormSpannungsteiler.SpinButtonR1DownClick(Sender: TObject);
begin
  editR1.text:=prevVal(editR1.text);
end;

procedure TFormSpannungsteiler.SpinButtonR2DownClick(Sender: TObject);
begin
  editR2.text:=prevVal(editR2.text);
end;

procedure TFormSpannungsteiler.SpinButtonR2UpClick(Sender: TObject);
begin
  editR2.text:=nextVal(editR2.text);
end;

procedure TFormSpannungsteiler.EditR1KeyPress(Sender: TObject; var Key: Char);
begin
  key:=uppercase(key)[1];
  if not (key in  ['0'..'9',',','.',#8,'M','K','R' ]) then key:=#0;
end;

procedure TFormSpannungsteiler.EditR2KeyPress(Sender: TObject; var Key: Char);
begin
  key:=uppercase(key)[1];
  if not (key in  ['0'..'9',',','.',#8,'M','K','R' ]) then key:=#0;
end;

procedure TFormSpannungsteiler.EditStromMaxKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (key in ['0'..'9',',','.',#8 ]) then key:=#0;
  if (key='.') or (key=',') then key:=DecimalSeparator;
end;

procedure TFormSpannungsteiler.EditStromMinKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (key in ['0'..'9',',','.',#8 ]) then key:=#0;
  if (key='.') or (key=',') then key:=DecimalSeparator;
end;

procedure TFormSpannungsteiler.EditStromMinMaxChange(Sender: TObject);
begin
  try
    iMaxLimit:=StrToFloat(EditStromMax.text);
    iMax:=iMaxLimit;
    iMinLimit:=StrToFloat(EditStromMin.text);
    iMin:=iMinLimit;
    Berechne;
  except
  end;
end;


procedure TFormSpannungsteiler.SpinButtonStromUpClick(Sender: TObject);
begin
  try
    iMax:=iMaxLimit;
    iMin:=Iist*1000+0.0001;
    if iMin< iMinLimit then iMin:=iMinLimit;
    if imax>iMin
    then begin
      sucheAufwaerts:=true;
      Berechne;
    end;
  except
  end;
end;

procedure TFormSpannungsteiler.SpinButtonStromDownClick(Sender: TObject);
begin
  try
    iMin:=iMinLimit;
    iMax:=Iist*1000-0.00001;
    if iMax> iMaxLimit then iMax:=iMaxLimit;
    if imax>iMin
    then begin
      sucheAufwaerts:=false;
      Berechne;
    end;
  except
  end;
end;

procedure TFormSpannungsteiler.calc3;
var
  rx, u2Ist, abweichung:double;
  i:integer;
begin
  try
    u1:=StrToFloat(EditU1.text);
    u2:=StrToFloat(EditU2.text);
    r1:=RtxtToNum(EditR1.text);
    r2:=RtxtToNum(EditR2.text);

    rx := (u1-u2)*r1/u2;

    i:=1;
    while (i<reiheAnzahl) and (reihe[i]<rx) do inc(i);
    if i>1 then begin
      if (reihe[i]-rx) > (rx-reihe[i-1]) then dec(i);
    end;
    r2:=reihe[i];

    EditR2.text:=NumToRTxt(r2);
    LabelR2.caption:=EditR2.text;
    Iist:=u1 / (r1+r2);
    u2Ist:=u1*r1 / (r1+r2);

    labelStrom.caption:=stromausgabe(Iist);
    labelu2Ist.caption:=spannungsausgabe(u2Ist);
    abweichung:=100*((u2Ist-u2)/u2);
    LabelAbweichung.caption:='Abweichung: '+floatToStrF(abweichung, ffFixed,7,2)+'%';
    Toleranzberechnung(u1,u2ist,r1,r2);

  except
    Labelu2Ist.caption:='-?-';
    labelStrom.caption:='I=-?-';
    LabelAbweichung.caption:='-?-';
    LabelR1.caption:='-?-';
    LabelR2.caption:='-?-';
  end;

end;

procedure TFormSpannungsteiler.calc4;
var
  rx, u2Ist, abweichung:double;
  i:integer;
begin
  try
    u1:=StrToFloat(EditU1.text);
    u2:=StrToFloat(EditU2.text);
    r1:=RtxtToNum(EditR1.text);
    r2:=RtxtToNum(EditR2.text);

    rx := u2*r2/(u1-u2);

    i:=1;
    while (i<reiheAnzahl) and (reihe[i]<rx) do inc(i);
    if i>1 then begin
      if (reihe[i]-rx) > (rx-reihe[i-1]) then dec(i);
    end;
    r1:=reihe[i];

    EditR1.text:=NumToRTxt(r1);
    LabelR1.caption:=EditR1.text;
    Iist:=u1 / (r1+r2);
    u2Ist:=u1*r1 / (r1+r2);

    labelStrom.caption:=stromausgabe(Iist);
    labelu2Ist.caption:=spannungsausgabe(u2Ist);
    abweichung:=100*((u2Ist-u2)/u2);
    LabelAbweichung.caption:='Abweichung: '+floatToStrF(abweichung, ffFixed,7,2)+'%';
    Toleranzberechnung(u1,u2ist,r1,r2);
  except
    Labelu2Ist.caption:='-?-';
    labelStrom.caption:='I=-?-';
    LabelAbweichung.caption:='-?-';
    LabelR1.caption:='-?-';
    LabelR2.caption:='-?-';
  end;

end;

function TFormSpannungsteiler.stromausgabe(i: double): string;
var
  einheit:string;
begin
  einheit:='A';
  if i > 1000 then begin
    i:=i/1000;
    einheit:='KA';
  end;
  if i < 1.0 then begin
    i:=i*1000;
    einheit:='mA';
  end;
  if i < 1.0 then begin
    i:=i*1000;
    einheit:='A';
  end;
  if i < 1.0 then begin
    i:=i*1000;
    einheit:='nA';
  end;
  result:='I='+floatToStrF(i,ffGeneral,7,5)+einheit;
end;

function TFormSpannungsteiler.spannungsausgabe(u: double): string;
var
  einheit:string;
begin
  einheit:='V';
  if u > 1000 then begin
    u:=u/1000;
    einheit:='KV';
  end;
  if u < 1.0 then begin
    u:=u*1000;
    einheit:='mV';
  end;
  if u < 1.0 then begin
    u:=u*1000;
    einheit:='V';
  end;
  if u < 1.0 then begin
    u:=u*1000;
    einheit:='nV';
  end;
//  result:=floatToStrF(u,ffFixed,15,5)+einheit;
  result:=floatToStrF(u,ffGeneral,7,5)+einheit;
end;

procedure TFormSpannungsteiler.calc5;
begin
  error:=false;
  try
    u2:=StrToFloat(EditU2.text);
    r1:=RtxtToNum(EditR1.text);
    r2:=RtxtToNum(EditR2.text);
    u1:=u2*(r1+r2)/r1;
    EditU1.text:=floatToStr(u1);
    LabelU1ist.caption:=spannungsausgabe(u1);
    Iist:=u1 / (r1+r2);
    labelStrom.caption:=stromausgabe(Iist);
    ToleranzberechnungU1(u1,u2,r1,r2);
  except
    error:=true;
    Labelu2Ist.caption:='-?-';
    labelStrom.caption:='I=-?-';
  end;
end;

function TFormSpannungsteiler.leistungssausgabe(p: double): string;
var
  einheit:string;
begin
  einheit:='W';
  if p > 1000000 then begin
    p:=p/1000000;
    einheit:='MW';
  end;
  if p > 1000 then begin
    p:=p/1000;
    einheit:='KW';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='mW';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='W';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='nW';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='pW';
  end;
  if p < 1.0 then begin
    p:=p*1000;
    einheit:='fW';
  end;
  result:=floatToStrF(p,ffGeneral,4,2)+einheit;
end;

procedure TFormSpannungsteiler.EditToleranzChange(Sender: TObject);
begin
  try
    toleranz:=strToFloat(EditToleranz.text)/100;
    berechne;
  except
  end;
end;


procedure TFormSpannungsteiler.EditToleranzKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (key in ['0'..'9',',','.',#8 ]) then key:=#0;
  if (key='.') or (key=',') then key:=DecimalSeparator;
end;

procedure TFormSpannungsteiler.EditU1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in ['0'..'9',',','.',#8 ]) then key:=#0;
  if (key='.') or (key=',') then key:=DecimalSeparator;
end;

procedure TFormSpannungsteiler.EditU2KeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in ['0'..'9',',','.',#8 ]) then key:=#0;
  if (key='.') or (key=',') then key:=DecimalSeparator;
end;

procedure TFormSpannungsteiler.Toleranzberechnung(u1,u2,r1,r2:double);
var
  r1max,r2max,r1min,r2min,u2min,u2max:double;
begin
    r1max:=r1*(1+toleranz);
    r2max:=r2*(1+toleranz);
    r1min:=r1*(1-toleranz);
    r2min:=r2*(1-toleranz);
    u2min:=u1* (r1min/(r1min+r2max));
    u2max:=u1* (r1max/(r1max+r2min));

    LabelUtoleranz.Caption:='U2';
    LabelU2min.Caption:=spannungsausgabe(u2min);
    LabelU2max.Caption:=spannungsausgabe(u2max);
    LabelU2Delta.caption:=spannungsausgabe(u2max-u2min);
    LabelDeltaProzent.caption:='('+floatToStrF( 100*((u2max-u2min)/u2),ffFixed,4,2)+'%)';
//    LabelU2DeltaProzent.caption:=floatToStrF( 100*((u2max-u2min)/u2),ffFixed,4,2);
    Application.ProcessMessages;
    LabelU2Delta.Left:=labelU2min.left + labelU2min.width;
//    LabelU2max.Left:=Label3Punkte.Left + Label3Punkte.width + 4;
    LabelU2max.Left:=LabelU2Delta.left+ LabelU2Delta.width;
    Label3Punkte.Left:=LabelU2Delta.left + (LabelU2Delta.width - Label3Punkte.width) div 2 ;
    LabelDeltaProzent.Left:=LabelU2Delta.left + (LabelU2Delta.width - LabelDeltaProzent.width) div 2 ;
end;

procedure TFormSpannungsteiler.ToleranzberechnungU1(u1, u2, r1, r2: double);
var
  r1max,r2max,r1min,r2min,u1min,u1max:double;
begin
    r1max:=r1*(1+toleranz);
    r2max:=r2*(1+toleranz);
    r1min:=r1*(1-toleranz);
    r2min:=r2*(1-toleranz);

    u1max:=u2* (r1min+r2max)/r1min;
    u1min:=u2* (r1max+r2min)/r1max;
    LabelUtoleranz.Caption:='U1';
    LabelU2min.Caption:=spannungsausgabe(u1min);
    LabelU2max.Caption:=spannungsausgabe(u1max);
    LabelU2Delta.caption:=spannungsausgabe(u1max-u1min);
    LabelDeltaProzent.caption:=' ('+floatToStrF( 100*((u1max-u1min)/u1),ffFixed,4,2)+'%)';
    Application.ProcessMessages;

    LabelU2Delta.Left:=labelU2min.left + labelU2min.width;
    LabelU2max.Left:=LabelU2Delta.left+ LabelU2Delta.width;
    Label3Punkte.Left:=LabelU2Delta.left + (LabelU2Delta.width - Label3Punkte.width) div 2 ;
    LabelDeltaProzent.Left:=LabelU2Delta.left + (LabelU2Delta.width - LabelDeltaProzent.width) div 2 ;
end;

end.
